//+------------------------------------------------------------------+
//|                                          Indicator: RSICross.mq4 |
//|                                       Created with EABuilder.com |
//|                                            https://eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "https://eabuilder.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 6

#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 0xFFAA00
#property indicator_label1 "Uptrend"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x0000FF
#property indicator_label2 "DownTrend"

#property indicator_type3 DRAW_ARROW
#property indicator_width3 3
#property indicator_color3 0xFFAA00
#property indicator_label3 "Buy"

#property indicator_type4 DRAW_ARROW
#property indicator_width4 3
#property indicator_color4 0x0000FF
#property indicator_label4 "Sell"

#property indicator_type5 DRAW_ARROW
#property indicator_width5 3
#property indicator_color5 0xFFAA00
#property indicator_label5 "CloseBuy"

#property indicator_type6 DRAW_ARROW
#property indicator_width6 3
#property indicator_color6 0x0000FF
#property indicator_label6 "CloseSell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];

extern int SlowRSI = 610;
extern int FastRSI = 144;
extern int FastMA = 7;
extern int SlowMA = 44;
datetime time_alert; //used when sending alert
bool Push_Notifications = true;
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | RSICross @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
   else if(type == "indicator")
     {
      if(Push_Notifications) SendNotification(type+" | RSICross @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(6);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexArrow(0, 252);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexArrow(1, 252);
   SetIndexBuffer(2, Buffer3);
   SetIndexEmptyValue(2, EMPTY_VALUE);
   SetIndexArrow(2, 241);
   SetIndexBuffer(3, Buffer4);
   SetIndexEmptyValue(3, EMPTY_VALUE);
   SetIndexArrow(3, 242);
   SetIndexBuffer(4, Buffer5);
   SetIndexEmptyValue(4, EMPTY_VALUE);
   SetIndexArrow(4, 251);
   SetIndexBuffer(5, Buffer6);
   SetIndexEmptyValue(5, EMPTY_VALUE);
   SetIndexArrow(5, 251);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   ArraySetAsSeries(Buffer3, true);
   ArraySetAsSeries(Buffer4, true);
   ArraySetAsSeries(Buffer5, true);
   ArraySetAsSeries(Buffer6, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
      ArrayInitialize(Buffer3, 0);
      ArrayInitialize(Buffer4, 0);
      ArrayInitialize(Buffer5, 0);
      ArrayInitialize(Buffer6, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      
      //Indicator Buffer 1
      if(iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i) > iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i)
      && iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i+1) < iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i+1) //Relative Strength Index crosses above Relative Strength Index
      )
        {
         Buffer1[i] = Low[i]; //Set indicator value at Candlestick Low
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "Uptrend"); //Alert on next bar open
         time_alert = Time[1];
        }
      else
        {
         Buffer1[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 2
      if(iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i) < iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i)
      && iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i+1) > iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i+1) //Relative Strength Index crosses below Relative Strength Index
      )
        {
         Buffer2[i] = High[i]; //Set indicator value at Candlestick High
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "DownTrend"); //Alert on next bar open
         time_alert = Time[1];
        }
      else
        {
         Buffer2[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 3
      if(iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i+1) < iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i+1) //Moving Average crosses above Moving Average
      && iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i) > iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i) //Relative Strength Index > Relative Strength Index
      )
        {
         Buffer3[i] = Low[i]; //Set indicator value at Candlestick Low
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "Buy"); //Alert on next bar open
         time_alert = Time[1];
        }
      else
        {
         Buffer3[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 4
      if(iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i+1) > iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i+1) //Moving Average crosses below Moving Average
      && iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i) < iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i) //Relative Strength Index < Relative Strength Index
      )
        {
         Buffer4[i] = High[i]; //Set indicator value at Candlestick High
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "Sell"); //Alert on next bar open
         time_alert = Time[1];
        }
      else
        {
         Buffer4[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 5
      if(iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i+1) > iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i+1) //Moving Average crosses below Moving Average
      && iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i) > iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i) //Relative Strength Index > Relative Strength Index
      )
        {
         Buffer5[i] = High[i]; //Set indicator value at Candlestick High
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "CloseBuy"); //Alert on next bar open
         time_alert = Time[1];
        }
      else
        {
         Buffer5[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 6
      if(iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_SMA, PRICE_CLOSE, i+1) < iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_SMA, PRICE_CLOSE, i+1) //Moving Average crosses above Moving Average
      && iRSI(NULL, PERIOD_CURRENT, FastRSI, PRICE_MEDIAN, i) < iRSI(NULL, PERIOD_CURRENT, SlowRSI, PRICE_CLOSE, i) //Relative Strength Index < Relative Strength Index
      )
        {
         Buffer6[i] = Low[i]; //Set indicator value at Candlestick Low
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "CloseSell"); //Alert on next bar open
         time_alert = Time[1];
        }
      else
        {
         Buffer6[i] = EMPTY_VALUE;
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+